#####################################################################
#Model to rewrite BBV1 file inserting data relative to the scene's objects. On reloading BBV1 file the list in panel "BioBlender View Proteins List" is populated and updated.
#####################################################################


from bpy import *
from . import store
from . import helpers
from .core import *
from . import BBV2
# Make aliases for a few commonly used bpy types
StringOBJ = props.StringProperty
String = props.StringProperty
Float = props.FloatProperty
Int = props.IntProperty
Bool = props.BoolProperty
Enum = props.EnumProperty
SelectFilterOld=0
SelectFilterProteinsOld=0
SelectFilterChainsOld=0
print("Im reloading BV1")

class BBPanel1():
	bl_space_type = 'PROPERTIES'
	bl_region_type = 'WINDOW'
	bl_context = "scene"
	@classmethod
	def poll(cls, context):
		try:
			# prevent the user from doing anything silly with the template file
			# by immediately save the file as a different file.
			# this means the only way to edit template.blend is by commenting out the following codes
			if os.path.basename(context.blend_data.filepath) == "template.blend":
				dir = os.path.dirname(context.blend_data.filepath)
				name = "untitled.blend"
				ops.wm.save_as_mainfile(filepath=os.path.join(dir, name))
			global SelectFilterProteinsOld
			if SelectFilterProteinsOld != context.scene.BBViewProteinsList:
				SelectFilterProteinsOld = context.scene.BBViewProteinsList
				print("proteins:"+str(context.scene.BBViewProteinsList))
				write_aminoacids_for_protein(this_protein=str(context.scene.BBViewProteinsList), verbose =  False)
				reload(BBV2)
		except Exception as E:
			s = "Context Poll Failed: " + str(E)
			myerr=""
			if len(str(E))> 31 and str(E)[0:31]=="'Scene' object has no attribute":
				myerr="noerr"
			if myerr!="noerr":
				print (s)
				errorNotifier(text=s)
		# check for the correct context
		return (context.scene)

class BBPanel_Proteins_List(BBPanel1, types.Panel):
	bl_label = 'BioBlender View Proteins list'
	def draw(self, context):
		scene = context.scene
		layout = self.layout
		split = layout.split(percentage=0.7)
		c=split.column()
		c.prop(scene, 'BBViewProteinsList', expand=True)
		right = split.column()
		c = right.column(align=True)
		c.operator("BBOperatorUpdate",text="Update Lists",icon="FILE_REFRESH")
